xquery version "1.0" encoding "UTF-8";

module namespace ddtek = "http://www.datadirect.com/xquery";

(: XQuery built-in functions :)

declare function fn:abs($arg as numeric?) as numeric? external;
declare function fn:adjust-date-to-timezone($arg as xs:date?) as xs:date? external;
declare function fn:adjust-date-to-timezone($arg as xs:date?, $timezone as xs:dayTimeDuration?) as xs:date? external;
declare function fn:adjust-dateTime-to-timezone($arg as xs:dateTime?) as xs:dateTime? external;
declare function fn:adjust-dateTime-to-timezone($arg as xs:dateTime?, $timezone as xs:dayTimeDuration?) as xs:dateTime? external;
declare function fn:adjust-time-to-timezone($arg as xs:time?) as xs:time? external;
declare function fn:adjust-time-to-timezone($arg as xs:time?, $timezone as xs:dayTimeDuration?) as xs:time? external;
declare function fn:avg($arg as xs:anyAtomicType*) as xs:anyAtomicType? external;
declare function fn:base-uri() as xs:anyURI? external;
declare function fn:base-uri($arg as node()?) as xs:anyURI? external;
declare function fn:boolean($arg as item()*) as xs:boolean external;
declare function fn:ceiling($arg as numeric?) as numeric? external;
declare function fn:codepoint-equal($comparand1 as xs:string?, $comparand2 as xs:string?) as xs:boolean? external;
declare function fn:codepoints-to-string($arg as xs:integer*) as xs:string external;
declare function fn:collection() as node()* external;
declare function fn:collection($arg as xs:string?) as node()* external;
declare function fn:compare($comparand1 as xs:string?, $comparand2 as xs:string?) as xs:integer? external;
declare function fn:compare($comparand1 as xs:string?, $comparand2 as xs:string?, $collation as xs:string) as xs:integer? external;
declare function fn:concat($arg1 as xs:anyAtomicType?, $arg2 as xs:anyAtomicType?) as xs:string external;
declare function fn:contains($arg1 as xs:string?, $arg2 as xs:string?) as xs:boolean external;
declare function fn:contains($arg1 as xs:string?, $arg2 as xs:string?, $collation as xs:string) as xs:boolean external;
declare function fn:count($arg as item()*) as xs:integer external;
declare function fn:current-date() as xs:date external;
declare function fn:current-dateTime() as xs:dateTime external;
declare function fn:current-time() as xs:time external;
declare function fn:data($arg as item()*) as xs:anyAtomicType* external;
declare function fn:dateTime($arg1 as xs:date?, $arg2 as xs:time?) as xs:dateTime? external;
declare function fn:day-from-date($arg as xs:date?) as xs:integer? external;
declare function fn:day-from-dateTime($arg as xs:dateTime?) as xs:integer? external;
declare function fn:days-from-duration($arg as xs:duration?) as xs:integer? external;
declare function fn:deep-equal($parameter1 as item()*, $parameter2 as item()*) as xs:boolean external;
declare function fn:deep-equal($parameter1 as item()*, $parameter2 as item()*, $collation as xs:string) as xs:boolean external;
declare function fn:default-collation() as xs:string external;
declare function fn:distinct-values($arg as xs:anyAtomicType*) as xs:anyAtomicType* external;
declare function fn:distinct-values($arg as xs:anyAtomicType*, $collation as xs:string) as xs:anyAtomicType* external;
declare function fn:doc($uri as xs:string?) as document-node()? external;
declare function fn:doc-available($uri as xs:string?) as xs:boolean external;
declare function fn:document-uri($arg as node()?) as xs:anyURI? external;
declare function fn:empty($arg as item()*) as xs:boolean external;
declare function fn:encode-for-uri($uri-part as xs:string?) as xs:string external;
declare function fn:ends-with($arg1 as xs:string?, $arg2 as xs:string?) as xs:boolean external;
declare function fn:ends-with($arg1 as xs:string?, $arg2 as xs:string?, $collation as xs:string) as xs:boolean external;
declare function fn:error() as item()* external;
declare function fn:error($error as xs:QName) as item()* external;
declare function fn:error($error as xs:QName?, $description as xs:string) as item()* external;
declare function fn:error($error as xs:QName?, $description as xs:string, $error-object as item()*) as item()* external;
declare function fn:escape-html-uri($uri as xs:string?) as xs:string external;
declare function fn:exactly-one($arg as item()*) as item() external;
declare function fn:exists($arg as item()*) as xs:boolean external;
declare function fn:false() as xs:boolean external;
declare function fn:floor($arg as numeric?) as numeric? external;
declare function fn:hours-from-dateTime($arg as xs:dateTime?) as xs:integer? external;
declare function fn:hours-from-duration($arg as xs:duration?) as xs:integer? external;
declare function fn:hours-from-time($arg as xs:time?) as xs:integer? external;
declare function fn:id($arg as xs:string*) as element()* external;
declare function fn:id($arg as xs:string*, $node as node()) as element()* external;
declare function fn:idref($arg as xs:string*) as node()* external;
declare function fn:idref($arg as xs:string*, $node as node()) as node()* external;
declare function fn:implicit-timezone() as xs:dayTimeDuration external;
declare function fn:in-scope-prefixes($element as element()) as xs:string* external;
declare function fn:index-of($seqParam as xs:anyAtomicType*, $srchParam as xs:anyAtomicType) as xs:integer* external;
declare function fn:index-of($seqParam as xs:anyAtomicType*, $srchParam as xs:anyAtomicType, $collation as xs:string) as xs:integer* external;
declare function fn:insert-before($target as item()*, $position as xs:integer, $inserts as item()*) as item()* external;
declare function fn:iri-to-uri($uri-part as xs:string?) as xs:string external;
declare function fn:lang($testlang as xs:string?) as xs:boolean external;
declare function fn:lang($testlang as xs:string?, $node as node()) as xs:boolean external;
declare function fn:last() as xs:integer external;
declare function fn:local-name() as xs:string external;
declare function fn:local-name($arg as node()?) as xs:string external;
declare function fn:local-name-from-QName($arg as xs:QName?) as xs:NCName? external;
declare function fn:lower-case($arg as xs:string?) as xs:string external;
declare function fn:matches($input as xs:string?, $pattern as xs:string) as xs:boolean external;
declare function fn:matches($input as xs:string?, $pattern as xs:string, $flags as xs:string) as xs:boolean external;
declare function fn:max($arg as xs:anyAtomicType*) as xs:anyAtomicType? external;
declare function fn:max($arg as xs:anyAtomicType*, $collation as xs:string) as xs:anyAtomicType? external;
declare function fn:min($arg as xs:anyAtomicType*) as xs:anyAtomicType? external;
declare function fn:min($arg as xs:anyAtomicType*, $collation as xs:string) as xs:anyAtomicType? external;
declare function fn:minutes-from-dateTime($arg as xs:dateTime?) as xs:integer? external;
declare function fn:minutes-from-duration($arg as xs:duration?) as xs:integer? external;
declare function fn:minutes-from-time($arg as xs:time?) as xs:integer? external;
declare function fn:month-from-date($arg as xs:date?) as xs:integer? external;
declare function fn:month-from-dateTime($arg as xs:dateTime?) as xs:integer? external;
declare function fn:months-from-duration($arg as xs:duration?) as xs:integer? external;
declare function fn:name() as xs:string external;
declare function fn:name($arg as node()?) as xs:string external;
declare function fn:namespace-uri() as xs:anyURI external;
declare function fn:namespace-uri($arg as node()?) as xs:anyURI external;
declare function fn:namespace-uri-for-prefix($prefix as xs:string?, $element as element()) as xs:anyURI? external;
declare function fn:namespace-uri-from-QName($arg as xs:QName?) as xs:anyURI? external;
declare function fn:nilled($arg as node()?) as xs:boolean? external;
declare function fn:node-name($arg as node()?) as xs:QName? external;
declare function fn:normalize-space() as xs:string external;
declare function fn:normalize-space($arg as xs:string?) as xs:string external;
declare function fn:normalize-unicode($arg as xs:string?) as xs:string external;
declare function fn:normalize-unicode($arg as xs:string?, $normalizationForm as xs:string) as xs:string external;
declare function fn:not($arg as item()*) as xs:boolean external;
declare function fn:number() as xs:double external;
declare function fn:number($arg as xs:anyAtomicType?) as xs:double external;
declare function fn:one-or-more($arg as item()*) as item()+ external;
declare function fn:position() as xs:integer external;
declare function fn:prefix-from-QName($arg as xs:QName?) as xs:NCName? external;
declare function fn:put($node as node(), $uri as xs:string) as empty-sequence() external;
declare function fn:QName($paramURI as xs:string?, $paramQName as xs:string) as xs:QName external;
declare function fn:remove($target as item()*, $position as xs:integer) as item()* external;
declare function fn:replace($input as xs:string?, $pattern as xs:string, $replacement as xs:string) as xs:string external;
declare function fn:replace($input as xs:string?, $pattern as xs:string, $replacement as xs:string, $flags as xs:string) as xs:string external;
declare function fn:resolve-QName($qname as xs:string?, $element as element()) as xs:QName? external;
declare function fn:resolve-uri($relative as xs:string?) as xs:anyURI? external;
declare function fn:resolve-uri($relative as xs:string?, $base as xs:string) as xs:anyURI? external;
declare function fn:reverse($arg as item()*) as item()* external;
declare function fn:root() as node() external;
declare function fn:root($arg as node()?) as node()? external;
declare function fn:round($arg as numeric?) as numeric? external;
declare function fn:round-half-to-even($arg as numeric?) as numeric? external;
declare function fn:round-half-to-even($arg as numeric?, $precision as xs:integer) as numeric? external;
declare function fn:seconds-from-dateTime($arg as xs:dateTime?) as xs:decimal? external;
declare function fn:seconds-from-duration($arg as xs:duration?) as xs:decimal? external;
declare function fn:seconds-from-time($arg as xs:time?) as xs:decimal? external;
declare function fn:starts-with($arg1 as xs:string?, $arg2 as xs:string?) as xs:boolean external;
declare function fn:starts-with($arg1 as xs:string?, $arg2 as xs:string?, $collation as xs:string) as xs:boolean external;
declare function fn:static-base-uri() as xs:anyURI? external;
declare function fn:string() as xs:string external;
declare function fn:string($arg as item()?) as xs:string external;
declare function fn:string-join($arg1 as xs:string*, $arg2 as xs:string) as xs:string external;
declare function fn:string-length() as xs:integer external;
declare function fn:string-length($arg as xs:string?) as xs:integer external;
declare function fn:string-to-codepoints($arg as xs:string?) as xs:integer* external;
declare function fn:subsequence($sourceSeq as item()*, $startingLoc as xs:double) as item()* external;
declare function fn:subsequence($sourceSeq as item()*, $startingLoc as xs:double, $length as xs:double) as item()* external;
declare function fn:substring($sourceString as xs:string?, $startingLoc as xs:double) as xs:string external;
declare function fn:substring($sourceString as xs:string?, $startingLoc as xs:double, $length as xs:double) as xs:string external;
declare function fn:substring-after($arg1 as xs:string?, $arg2 as xs:string?) as xs:string external;
declare function fn:substring-after($arg1 as xs:string?, $arg2 as xs:string?, $collation as xs:string) as xs:string external;
declare function fn:substring-before($arg1 as xs:string?, $arg2 as xs:string?) as xs:string external;
declare function fn:substring-before($arg1 as xs:string?, $arg2 as xs:string?, $collation as xs:string) as xs:string external;
declare function fn:sum($arg as xs:anyAtomicType*) as xs:anyAtomicType external;
declare function fn:sum($arg as xs:anyAtomicType*, $zero as xs:anyAtomicType?) as xs:anyAtomicType? external;
declare function fn:timezone-from-date($arg as xs:date?) as xs:dayTimeDuration? external;
declare function fn:timezone-from-dateTime($arg as xs:dateTime?) as xs:dayTimeDuration? external;
declare function fn:timezone-from-time($arg as xs:time?) as xs:dayTimeDuration? external;
declare function fn:tokenize($input as xs:string?, $pattern as xs:string) as xs:string* external;
declare function fn:tokenize($input as xs:string?, $pattern as xs:string, $flags as xs:string) as xs:string* external;
declare function fn:trace($value as item()*, $label as xs:string) as item()* external;
declare function fn:translate($arg as xs:string?, $mapString as xs:string, $transString as xs:string) as xs:string external;
declare function fn:true() as xs:boolean external;
declare function fn:unordered($sourceSeq as item()*) as item()* external;
declare function fn:upper-case($arg as xs:string?) as xs:string external;
declare function fn:year-from-date($arg as xs:date?) as xs:integer? external;
declare function fn:year-from-dateTime($arg as xs:dateTime?) as xs:integer? external;
declare function fn:years-from-duration($arg as xs:duration?) as xs:integer? external;
declare function fn:zero-or-one($arg as item()*) as item()? external;

(: XQuery constructor functions :)

declare function xs:string($arg as xs:anyAtomicType?) as xs:string? external;
declare function xs:boolean($arg as xs:anyAtomicType?) as xs:boolean? external;
declare function xs:decimal($arg as xs:anyAtomicType?) as xs:decimal? external;
declare function xs:float($arg as xs:anyAtomicType?) as xs:float? external;
declare function xs:double($arg as xs:anyAtomicType?) as xs:double? external;
declare function xs:duration($arg as xs:anyAtomicType?) as xs:duration? external;
declare function xs:dateTime($arg as xs:anyAtomicType?) as xs:dateTime? external;
declare function xs:time($arg as xs:anyAtomicType?) as xs:time? external;
declare function xs:date($arg as xs:anyAtomicType?) as xs:date? external;
declare function xs:gYearMonth($arg as xs:anyAtomicType?) as xs:gYearMonth? external;
declare function xs:gYear($arg as xs:anyAtomicType?) as xs:gYear? external;
declare function xs:gMonthDay($arg as xs:anyAtomicType?) as xs:gMonthDay? external;
declare function xs:gDay($arg as xs:anyAtomicType?) as xs:gDay? external;
declare function xs:gMonth($arg as xs:anyAtomicType?) as xs:gMonth? external;
declare function xs:hexBinary($arg as xs:anyAtomicType?) as xs:hexBinary? external;
declare function xs:base64Binary($arg as xs:anyAtomicType?) as xs:base64Binary? external;
declare function xs:anyURI($arg as xs:anyAtomicType?) as xs:anyURI? external;
declare function xs:QName($arg as xs:anyAtomicType) as xs:QName? external;
declare function xs:normalizedString($arg as xs:anyAtomicType?) as xs:normalizedString? external;
declare function xs:token($arg as xs:anyAtomicType?) as xs:token? external;
declare function xs:language($arg as xs:anyAtomicType?) as xs:language? external;
declare function xs:NMTOKEN($arg as xs:anyAtomicType?) as xs:NMTOKEN? external;
declare function xs:Name($arg as xs:anyAtomicType?) as xs:Name? external;
declare function xs:NCName($arg as xs:anyAtomicType?) as xs:NCName? external;
declare function xs:ID($arg as xs:anyAtomicType?) as xs:ID? external;
declare function xs:IDREF($arg as xs:anyAtomicType?) as xs:IDREF? external;
declare function xs:ENTITY($arg as xs:anyAtomicType?) as xs:ENTITY? external;
declare function xs:integer($arg as xs:anyAtomicType?) as xs:integer? external;
declare function xs:nonPositiveInteger($arg as xs:anyAtomicType?) as xs:nonPositiveInteger? external;
declare function xs:negativeInteger($arg as xs:anyAtomicType?) as xs:negativeInteger? external;
declare function xs:long($arg as xs:anyAtomicType?) as xs:long? external;
declare function xs:int($arg as xs:anyAtomicType?) as xs:int? external;
declare function xs:short($arg as xs:anyAtomicType?) as xs:short? external;
declare function xs:byte($arg as xs:anyAtomicType?) as xs:byte? external;
declare function xs:nonNegativeInteger($arg as xs:anyAtomicType?) as xs:nonNegativeInteger? external;
declare function xs:unsignedLong($arg as xs:anyAtomicType?) as xs:unsignedLong? external;
declare function xs:unsignedInt($arg as xs:anyAtomicType?) as xs:unsignedInt? external;
declare function xs:unsignedShort($arg as xs:anyAtomicType?) as xs:unsignedShort? external;
declare function xs:unsignedByte($arg as xs:anyAtomicType?) as xs:unsignedByte? external;
declare function xs:positiveInteger($arg as xs:anyAtomicType?) as xs:positiveInteger? external;
declare function xs:yearMonthDuration($arg as xs:anyAtomicType?) as xs:yearMonthDuration? external;
declare function xs:dayTimeDuration($arg as xs:anyAtomicType?) as xs:dayTimeDuration? external;
declare function xs:untypedAtomic($arg as xs:anyAtomicType?) as xs:untypedAtomic? external;

(: DataDirect built-in functions :)

declare function ddtek:decimal($arg as xs:anyAtomicType?, $precision as xs:integer, $scale as xs:integer) as xs:decimal? external;
declare function ddtek:validate($e as node(), $schema as xs:string) as node() external;
declare function ddtek:validate-and-report($e as node(), $schema as xs:string) as document-node() external;
declare function ddtek:isValid($e as node(), $schema as xs:string) as xs:boolean external;
declare function ddtek:info() as document-node() external;
declare function ddtek:parse($input as xs:string) as document-node(element(*,xs:untyped)) external;
declare function ddtek:parse-base64($input as xs:base64Binary) as document-node(element(*,xs:untyped)) external;
declare function ddtek:convert-to-xml($input as xs:string, $options as xs:string) as document-node(element(*,xs:untyped)) external;
declare function ddtek:serialize($items as item()*, $options as xs:string) as xs:string external;
declare function ddtek:serialize-to-base64($item as item()*, $options as xs:string) as xs:base64Binary external;
declare function ddtek:serialize-to-url($items as item()*, $url as xs:string, $options as xs:string) as empty-sequence() external;
declare function ddtek:javaCast($arg as ddtek:javaObject, $target as xs:string) as ddtek:javaObject external;
declare function ddtek:rtrim($arg as xs:string?) as xs:string? external;
declare function ddtek:ltrim($arg as xs:string?) as xs:string? external;
declare function ddtek:trim($arg as xs:string?) as xs:string? external;
declare function ddtek:wscall($location as element(), $payload as element()) as document-node(element(*,xs:untyped)) external;
declare function ddtek:wscall($location as element(), $header as element(), $payload as element()) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-delete($url as xs:string) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-delete($url as xs:string, $request as element()?) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-get($url as xs:string) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-get($url as xs:string, $request as element()?) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-head($url as xs:string) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-head($url as xs:string, $request as element()?) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-options($url as xs:string) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-options($url as xs:string, $request as element()?) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-post($url as xs:string, $payload as item()?) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-post($url as xs:string, $payload as item()?, $request as element()?) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-put($url as xs:string, $payload as item()?) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-put($url as xs:string, $payload as item()?, $request as element()?) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-trace($url as xs:string) as document-node(element(*,xs:untyped)) external;
declare function ddtek:http-trace($url as xs:string, $request as element()?) as document-node(element(*,xs:untyped)) external;
declare function ddtek:base64-to-string($input as xs:base64Binary?, $charset as xs:string?) as xs:string? external;
declare function ddtek:analyze-edi-from-url($url as xs:string)  as document-node(element(*, xs:untyped)) external;
declare function ddtek:analyze-edi-from-string($url as xs:string, $edi as xs:string) as document-node(element(*, xs:untyped)) external;
declare function ddtek:edi-to-xml-from-url($url as xs:string, $report as document-node(element(*, xs:untyped)) ) as document-node(element(*, xs:untyped)) external;
declare function ddtek:edi-to-xml-from-string($url as xs:string, $edi as xs:string, $report as document-node(element(*, xs:untyped)) ) as document-node(element(*, xs:untyped)) external;
declare function ddtek:format-number($number as numeric?, $format as xs:string) as xs:string external;
declare function ddtek:format-number($number as numeric?, $format as xs:string, $decimal-separator as xs:string?, $grouping-separator as xs:string?, $infinity as xs:string?, $minus-sign as xs:string?, $NaN as xs:string?, $percent as xs:string?, $per-mille as xs:string?, $zero-digit as xs:string?, $digit as xs:string?, $pattern-separator as xs:string?) as xs:string external;
declare function ddtek:format-dateTime($value as xs:dateTime?, $picture as xs:string) as xs:string? external;
declare function ddtek:format-dateTime($value as xs:dateTime?, $picture as xs:string, $language as xs:string?, $calendar as xs:string?, $country as xs:string?) as xs:string? external;
declare function ddtek:format-date($value as xs:date?, $picture as xs:string) as xs:string? external;
declare function ddtek:format-date($value as xs:date?, $picture as xs:string, $language as xs:string?, $calendar as xs:string?, $country as xs:string?) as xs:string? external;
declare function ddtek:format-time($value as xs:time?, $picture as xs:string) as xs:string? external;
declare function ddtek:format-time($value as xs:time?, $picture as xs:string, $language as xs:string?, $calendar as xs:string?, $country as xs:string?) as xs:string? external;

(: DataDirect SQLAdaptor SQL functions :)

declare function ddtek-sql:sqs-query($context-item as node()*, $query as xs:string) as node()* external;
declare function ddtek-sql:sqs-query($query as xs:string) as node()* external;
declare function ddtek-sql:sqs-value($context-item as node()*, $query as xs:string, $type as xs:string) as xs:anyAtomicType? external;
declare function ddtek-sql:sqs-exist($context-item as node()*, $query as xs:string) as xs:boolean external;
declare function ddtek-sql:sqs-nodes($context-item as node()*, $query as xs:string) as document-node(element()) external;
 
declare function ddtek-sql:ora-xmlquery($query as xs:string, $context-item as node()*) as node()* external;
declare function ddtek-sql:ora-xmlquery($query as xs:string) as node()* external;

declare function ddtek-sql:db2-xmlquery($query as xs:string) as node()* external;
declare function ddtek-sql:db2-xmlquery($query as xs:string, $paramvalue as item()*, $paramname as xs:string) as node()* external;
declare function ddtek-sql:db2-xmlparse($doc as xs:string) as node()* external;

declare updating function ddtek:sql-update($row-node as element()*, $colName as xs:string, $colValue as item()*) as empty-sequence() external;
declare updating function ddtek:sql-insert($tableName as xs:string, $colName as xs:string, $colValue as item()*) as empty-sequence() external;
declare updating function ddtek:sql-delete($row-node as element()*) as empty-sequence() external;

(: DataDirect SQLAdaptor functions :)

declare function ddtek-sa:table($p1 as xs:string, $p2 as xs:string, $p3 as xs:string) as element()* external;
declare function ddtek-sa:col($p1 as element(),$p2 as xs:string,$p3 as xs:integer,$p4 as xs:integer ) as xs:anyAtomicType? external;
declare function ddtek-sa:xmlcol($p1 as element(),$p2 as xs:string) as node()* external;
declare function ddtek-sa:i2n($p1 as item()* ) as node()* external;
declare function ddtek-sa:i2av($p as item()*) as xs:untypedAtomic? external;
declare function ddtek-sa:sortGroup($p1 as xs:string,$p2 as xs:anyAtomicType*) as xs:anyAtomicType* external;
declare function ddtek-sa:extvar($p1 as xs:string,$p2 as xs:integer,$p3 as xs:integer ) as xs:anyAtomicType* external;
declare function ddtek-sa:extVarInstances() as xs:integer* external;
declare function ddtek-sa:extVarInstance($p1 as xs:anyAtomicType*, $varIx as xs:integer) as xs:anyAtomicType* external;
declare function ddtek-sa:keyVal($p1 as xs:anyAtomicType*) as xs:string external;
declare function ddtek-sa:extKeyVal($p1 as xs:anyAtomicType*, $p2 as xs:string,$p3 as xs:integer,$p4 as xs:integer, $p5 as xs:integer) as xs:string external;
declare function ddtek-sa:ddo($p1 as node()* ) as node()* external;
declare function ddtek-sa:ifNull($p1 as xs:anyAtomicType?, $p2 as xs:anyAtomicType ) as xs:anyAtomicType external;
declare function ddtek-sa:pknode($row-node as element()) as element() external;
declare function ddtek-sa:str2xmlcol($str as xs:string) as element(ddtek-sa:dummyxmlcolelement) external;
declare function ddtek-sa:xmlquery($p1 as node()*) as node()* external;
declare function ddtek-sa:xmlunwrap($p1 as node()*, $type as xs:integer, $atomicType as xs:integer) as node()* external;
declare function ddtek-sa:xmlagg($p1 as node()*) as node()* external;

(: DataDirect mediator functions :)

declare function ddtek-me:is-bound($name as xs:string) as xs:boolean external;
